/************************************************************

	Author:						Manfred Langemann
	mailto:						Manfred.Langemann t t-online.de
	Begin of project:			20.06.2008
	Latest version generated:	28.06.2008
	Filename:					PWsaverFont.c
	Description:    			Fond functions
	Adapted from:				C. Petzold, Window Programming, Issue 5

 *************************************************************/
#include <windows.h>
#include <commdlg.h>

static LOGFONT logfont;
static HFONT   hFont;
/*************************************************************

	Function PWsaverFontChooseFont

	Purpose: Choose font dialog

 *************************************************************/
BOOL PWsaverFontChooseFont (HWND hwnd)
	{
	CHOOSEFONT cf;

	cf.lStructSize    = sizeof (CHOOSEFONT);
	cf.hwndOwner      = hwnd;
	cf.hDC            = NULL;
	cf.lpLogFont      = &logfont;
	cf.iPointSize     = 0;
	cf.Flags          = CF_INITTOLOGFONTSTRUCT | CF_SCREENFONTS | CF_EFFECTS;
	cf.rgbColors      = 0;
	cf.lCustData      = 0;
	cf.lpfnHook       = NULL;
	cf.lpTemplateName = NULL;
	cf.hInstance      = NULL;
	cf.lpszStyle      = NULL;
	cf.nFontType      = 0;               // von ChooseFont gesetzt
	cf.nSizeMin       = 0;
	cf.nSizeMax       = 0;

	return ChooseFont (&cf);
	}
/*************************************************************

	Function PWsaverFontInitialize

	Purpose: Initialise font

 *************************************************************/
void PWsaverFontInitialize (HWND hwndEdit)
	{
	GetObject (GetStockObject (ANSI_FIXED_FONT), sizeof (LOGFONT),(PTSTR) &logfont);

	hFont = CreateFontIndirect (&logfont);
	SendMessage (hwndEdit, WM_SETFONT, (WPARAM) hFont, 0);
	}
/*************************************************************

	Function PWsaverFontSetFont

	Purpose: Set font

 *************************************************************/
void PWsaverFontSetFont (HWND hwndEdit)
	{
	HFONT hFontNew;
	RECT  rect;
     
	hFontNew = CreateFontIndirect (&logfont);
	SendMessage (hwndEdit, WM_SETFONT, (WPARAM) hFontNew, 0);
	DeleteObject (hFont);
	hFont = hFontNew;
	GetClientRect (hwndEdit, &rect);
	InvalidateRect (hwndEdit, &rect, TRUE);
	}
/*************************************************************

	Function PWsaverFontDeinitialize

	Purpose: Deinitialise font

 *************************************************************/
void PWsaverFontDeinitialize (void)
	{
	DeleteObject (hFont);
	}
